<?php
use yii\helpers\Html;
use yii\helpers\ArrayHelper;
use yii\bootstrap\ActiveForm;
use app\components\ckeditor\CKEditor;
use app\mihaildev\elfinder\ElFinder;
use app\modules\admin\models\Catalog;
use app\modules\admin\models\Fasovka;
use app\modules\admin\models\Type;
use app\modules\admin\models\Brends;
?>

    <?php $form = ActiveForm::begin([
        'id' => 'form',
        'options' => ['enctype' => 'multipart/form-data'],

    ]); ?>

    <?= $form->field($model, 'catalog_id')->hiddenInput(['value'=>$_GET['catID']])->label(false); ?>

    <?= $form->field($model, 'art') ?>

    <?= $form->field($model, 'name') ?>

    <?= $form->field($model, 'translit',[
        'inputTemplate' => '<div class="input-group"><span class="input-group-addon">products/</span>{input}</div>',
    ]);?>
        
    <?= $form->field($model, 'image')->fileInput() ?>
        
    <?= $form->field($model, 'old_image')->hiddenInput(['value'=>$model->image])->label(false); ?>    

    <?=$form->field($model, 'body')->widget(CKEditor::className(),[
    'editorOptions' => ElFinder::ckeditorOptions('elfinder',[/* Some CKEditor Options */]),
    ]);
    ?>

    <?=$form->field($model, 'char')->widget(CKEditor::className(),[
    'editorOptions' => ElFinder::ckeditorOptions('elfinder',[/* Some CKEditor Options */]),
    ]);
    ?>

    <?= $form->field($model, 'new')->checkbox() ?>

    <?= $form->field($model, 'top')->checkbox() ?>

    <?= $form->field($model, 'akciya')->checkbox() ?>

    <?= $form->field($model, 'out_of_stock')->checkbox() ?>
    
<?= $form->field($model, 'fasovka')
        ->dropDownList(ArrayHelper::map(Fasovka::find()->where(['catalog_id'=>$_GET['catID']])->asArray()->orderBy('name')->all(), 'id', 'name'), ['multiple' => true])
    ?>

    <?= $form->field($model, 'type')
        ->dropDownList(ArrayHelper::map(Type::find()->where(['catalog_id'=>$_GET['catID']])->asArray()->orderBy('name')->all(), 'id', 'name'), ['multiple' => true])
    ?>

    <?= $form->field($model, 'brends')
        ->dropDownList(ArrayHelper::map(Brends::find()->where(['catalog_id'=>$_GET['catID']])->asArray()->orderBy('name')->all(), 'id', 'name'), ['multiple' => true])
    ?>

    <?= $form->field($model, 'similar')->hint('Через запятую введите АРТИКЛИ') ?>

    <?= $form->field($model, 'featured')->hint('Через запятую введите АРТИКЛИ') ?>

    <?= $form->field($model, 'meta_title') ?>

    <?= $form->field($model, 'meta_keywords') ?>

    <?= $form->field($model, 'meta_description') ?>


    <?= Html::submitButton('Сохранить', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>



    <?php ActiveForm::end(); ?>

